<?php
namespace App\Console\Commands;
use Illuminate\Console\Command;

use App\Http\Controllers\MassegesController;
use App\Models\Extension;
use Illuminate\Support\Facades\DB;
use Exception;
use Carbon\Carbon;
use App\Models\Subscription;
use App\Models\Transaction;
use App\Models\User;
use App\Models\Wallet;
use Illuminate\Support\Facades\Http;

class RenewUserSubscriptionCommand extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'RenewUserSubscriptionCommand';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return int
     */
    public function handle()
    {
        try {
            $currentDate = Carbon::now();
            $subscriptions = Subscription::whereRaw("STR_TO_DATE(end_date, '%Y-%m-%d') <= STR_TO_DATE(?, '%Y-%m-%d')", [$currentDate->toDateString()])->get();
            foreach ($subscriptions as $subscription) {
                if ($subscription->auto_renewal == 1 && $subscription->state == 1) {
                    $currentDate = Carbon::now();


                    DB::beginTransaction();
                    try {
                        //0 step identify some variables
                        $step1 = false;
                        $step3 = false;
                        //1 step => udating the duration



////////////////////////////////
//for testing phase
                        // $oldstart=Carbon::parse($subscription->start_date);
                        // $oldend=Carbon::parse($subscription->end_date);
                        // $dif=$oldstart->diffInDays($oldend);
                        // if($dif==0||$dif==null){
                        //     $dif=1;
                        // }
                        // $subscription->start_date = ($oldend->toDateString()) . ' 00:00:00.000';
                        // $subscription->end_date = $oldend->addDays($dif)->toDateString() . ' 00:00:00.000';
////////////////////////////////

                        $dif=Carbon::parse($subscription->start_date)->diffInDays(Carbon::parse($subscription->end_date));
                        if($dif==0||$dif==null){
                            $dif=1;
                        }
                        $subscription->start_date = ($currentDate->toDateString()) . ' 00:00:00.000';
                        $subscription->end_date = $currentDate->addDays($dif)->toDateString() . ' 00:00:00.000';
                        
                        
                        $subscription->seen = 0;
                        $subscription->state = 1;
                        $step1 = true;



                        //3 step => add the cost of renwal subscription to the remain amount
                        $payment_remain = ((Double)$subscription->payment_remain) + ((Double)$subscription->price); //subtract from subscription remain
                        $subscription->payment_remain = $payment_remain;
                        $step3 = $subscription->save();


                        if ($step1  && $step3) {



                            $user = User::find($subscription->user_id);
                            if($user){
                                
                                $start = $subscription->start_date;
                                $end = $subscription->end_date;
                                $remain = $subscription->payment_remain;
                                $renew = ($subscription->auto_renewal == 0) ? "غير تلقائي" : "تلقائي";
                                try {
                                    $message="عزيزي المشترك '$user->user_name' تم التجديد الباقه الخاصه بك من تاريخ '$start' إلى تاريخ '$end' والمبلغ المستحق '$remain'. لتسديد فواتيرك يرجى التوجه لسوبر ماركت بيت المونة بجانب البنك الاسلامي بإدراة يونس حنتولي";
                                    // $message="عزيزي المشترك '$user->user_name' في شبكة نيو برايت نت لقد تم التجديد الباقه الخاصه بك و تبدأ من تاريخ '$start' إلى تاريخ '$end' ونوع التجديد '$renew'. لتسديد فواتيرك يرجى التوجه لسوبر ماركت بيت المونة بجانب البنك الاسلامي بإدراة يونس حنتولي";
                                    $phone='+97'.$user->phone_number;
                                    $response = Http::get('http://triple-core.ps/sendbulksms.php?user_name=brightnet&user_pass=932420&sender=Bright Net&mobile='.$phone.'&type=0&text='.$message.'');
                                } catch (Exception $exception) {
                                }
                            }
                            DB::commit();
                        }
                    } catch (Exception $e) {
                        DB::rollback();
                        throw $e;
                    }
                } else {
                    DB::beginTransaction();
                    try {
                        $isExtended = Extension::where('subscription_id', $subscription->id)->exists();
                        if ($isExtended) {
                            $extension = Extension::where('subscription_id', $subscription->id)->first();
                            $endDate = $extension->end_date;
                            $end_date = Carbon::parse($endDate);

                            if ($end_date->isAfter($currentDate)) {
                                $extension->delete();
                                $subscription->state = 0;
                                $subscription->seen = 0;
                            }
                        } else {
                            $sub = Subscription::find($subscription->id);
                            $sub->state = 0;
                            $sub->seen = 0;
                        }


                        DB::commit();
                    } catch (Exception $e) {
                        DB::rollback();
                        throw $e;
                    }
                }
            }
        } catch (Exception $e) {
        }
        return 0;
    }
}
//115
//128
//131
//133
