<?php

namespace App\Console;

use Illuminate\Console\Scheduling\Schedule;
use Illuminate\Foundation\Console\Kernel as ConsoleKernel;
use App\Console\Commands\RenewUserSubscriptionCommand;
use App\Console\Commands\RemainPaymentUsers;


class Kernel extends ConsoleKernel
{
    /**
     * Define the application's command schedule.
     *
     * @param  \Illuminate\Console\Scheduling\Schedule  $schedule
     * @return void
     */
    protected function schedule(Schedule $schedule)
    {

        $schedule->command('RenewUserSubscriptionCommand')->everyMinute();
        $schedule->command('RemainPaymentUsers')->monthlyOn(15, '12:00');
        $schedule->command('RemainPaymentUsers')->monthlyOn(1, '12:00');


    }

    /**
     * Register the commands for the application.
     *
     * @return void
     */
    protected function commands()
    {
        $this->load(__DIR__.'/Commands');

        require base_path('routes/console.php');
    }
}
