<?php

namespace App\Http\Controllers;

use App\Models\Extension;
use App\Models\Subscription;
use App\Models\User;
use App\Traits\ApiResponseTrait;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Illuminate\Database\QueryException;
use Exception;

class ExtensionContreoller extends Controller
{

    use ApiResponseTrait;

    public function create(Request $request)
    {

        try {
            $rules = [
                'subscription_id' => "required|numeric",
                'end_date' => "required",

            ];

            $validator = Validator::make($request->all(), $rules);

            if ($validator->fails()) {
                $code = $this->returnCodeAccordingToInput($validator);
                return $this->returnValidationError($code, $validator);
            } else {
                $extension = new Extension();
                $extension->fill($request->all());
                $success = $extension->save();

                if ($success) {
                    $sub = Subscription::find($request->subscription_id);
                    $user = User::find($sub->user_id);
                    $MessageController = new MassegesController();

                    $end = substr($request->end_date, 0, 10);

                    try {
                        $MessageController->sendSmsMessage("عزيزي المشترك $user->name في شبكة نيو برايت نت لقد تم تمديد الباقه الخاصه بك إلى تاريخ $end . لتسديد فواتيرك يرجى التوجه لسوبر ماركت بيت المونة بجانب البنك الاسلامي بإدراة يونس حنتولي", $user->phone_number);
                    } catch (Exception $exception) {
                    }


                    return $this->returnData("extension", $extension, "the Subscription has been extension successfully!");
                } else {
                    return $this->error(1, "the user already have extension!");
                }
            }
        } catch (QueryException $e) {
            return $this->error(2, "the user already have extension!");
        } catch (Exception $e) {
            return $this->error(1, "some thing went wrong while Creating this extension!");
        }
    }
}
