<?php

namespace App\Http\Middleware;

use App\Traits\ApiResponseTrait;
use Closure;
use Illuminate\Http\Request;
use Tymon\JWTAuth\Facades\JWTAuth;
class CheckAdminToken
{
    use ApiResponseTrait;

    /**
     * Handle an incoming request.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \Closure(\Illuminate\Http\Request): (\Illuminate\Http\Response|\Illuminate\Http\RedirectResponse)  $next
     * @return \Illuminate\Http\Response|\Illuminate\Http\RedirectResponse
     */
    public function handle(Request $request, Closure $next)
    {
        $user =null;
        try{
            $user =JWTAuth::parseToken()->authinticate();
        }catch(\Exception $e){
            if($e instanceof \Tymon\JWTAuth\Exceptions\TokenInvalidException){
                return $this->error(2,'INVALID_TOKEN');
            }elseif($e instanceof \Tymon\JWTAuth\Exceptions\TokenInvalidException){
                return $this->error(2,'EXPAIRED_TOKEN');
            }else{
                return $this->error(2,'TOKEN_NOTFOUND');
            }
        }
        if(!$user){
            return $this->error(2,'UnAuthenticated');
        }
        return $next($request);
    }
}
