<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Tymon\JWTAuth\Contracts\JWTSubject;

class Subscription extends Authenticatable  implements JWTSubject
{
    protected $table = 'subscriptions';
    protected $fillable = [
        'id',
        'user_id',
        'package_id',
        'start_date',
        'end_date',
        'auto_renewal',
        'state',
        'price',
        'speed',
        'payment_remain',
        'payment_total',
        'note',
        'seen',
        'created_at',
        'updated_at'
    ];

    public function getJWTIdentifier()
    {
        return $this->getKey();
    }

    public function getJWTCustomClaims()
    {
        return [];
    }
}
