<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class SubscriptionLog extends Model
{
    protected $table = 'subscriptions_log';
    protected $fillable = [
        'id',
        'subscription_id',
        'user_id',
        'user_name',
        'user_phone',
        'package_id',
        'start_date',
        'end_date',
        'auto_renewal',
        'state',
        'price',
        'speed',
        'payment_remain',
        'payment_total',
        'note',
        'seen',
        'operation',
        'created_at',
        'updated_at'
    ];
    public function getJWTIdentifier()
    {
        return $this->getKey();
    }

    public function getJWTCustomClaims()
    {
        return [];
    }
}
