<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Tymon\JWTAuth\Contracts\JWTSubject;

class Transaction extends Authenticatable  implements JWTSubject
{
    protected $table = 'transactions';
    protected $fillable = [
        'id',
        'end_point_id',
        'user_id',
        'package_id',
        'subscription_id',
        'transaction_date',
        'payment_amount',
        'payment_method',
        'seen',
        'created_at',
        'updated_at'
    ];

    public function getJWTIdentifier()
    {
        return $this->getKey();
    }

    public function getJWTCustomClaims()
    {
        return [];
    }
}
